// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2021 Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using Hiperscan.Spectroscopy.IdentModule;

namespace Hiperscan.Extensions.ApoIdent
{
    public partial class SubstanceManagement
    {
        public void AddModelClassToResolver(ModelClassInfo model_class_info)
        {
            this.SubstanceResolver.AddModelClassToResolver(model_class_info);
        }

        public void RemoveUserdefinedModelClassFromResolver()
        {
            this.SubstanceResolver.RemoveUserdefinedModelClassFromResolver();
        }

        public ModelClassInfo GetModelClassificationInfo(string model_class_name)
        {
            return this.SubstanceResolver.GetModelClassificationInfo(model_class_name);
        }

        public HashSet<string> GetModelClassesBySubstanceName(string substance_name)
        {
            return this.SubstanceResolver.GetModelClassesBySubstanceName(substance_name);
        }

        public HashSet<string> GetModelClassesBySubstanceId(string substance_id)
        {
            return this.SubstanceResolver.GetModelClassesBySubstanceId(substance_id);
        }

        public SubstanceInfo GetSusbtanceInfo(string substance_id)
        {
            return this.SubstanceResolver.GetSusbtanceInfo(substance_id);
        }

        public bool SubstanceIdExists(string substance_id)
        {
            return this.SubstanceResolver.SubstanceIdExists(substance_id);
        }

        public bool SubstanceNameExists(string substance_name)
        {
            return this.SubstanceResolver.SubstanceNameExists(substance_name);
        }

        public List<ModelClassInfo> MasterModelClassInfos
        {
            get
            {
                return this.SubstanceResolver.MasterModelClassInfos;
            }
        }

        public HashSet<string> AllModelClassNames
        {
            get
            {
                return this.SubstanceResolver.AllModelClassNames;
            }
        }

        public bool HasUserDefinedModelClass
        {
            get
            {
                return this.SubstanceResolver.HasUserDefinedModelClass;
            }
        }

        public HashSet<string> AllSubstanceNames
        {
            get
            {
                return this.SubstanceResolver.AllSubstanceNames;
            }
        }

        public List<SubstanceListAutoCompletionEntry> AutpCompletionEntries
        {
            get
            {
                return this.SubstanceResolver.AutpCompletionEntries;
            }
        }

        private SubstanceResolver SubstanceResolver { get; set; } = new SubstanceResolver();
    }
}
